﻿using System;
using System.Collections.Generic;
using Couchbase.Lite;
using Couchbase.Lite.Query;
using Newtonsoft.Json;
using Xamarin.Forms;

namespace MappingTestApp
{
    public partial class TestPage : ContentPage
    {
        Database _database;

        Database Database
        {
            get
            {
                if (_database == null)
                {
                    _database = new Database("test");
                }

                return _database;
            }
        }

        public TestPage()
        {
            InitializeComponent();
        }

        public void Create_Clicked(object sender, EventArgs e)
        {
            string contractId = Guid.NewGuid().ToString();

            var products = new List<Roofing>();

            for (int i = 0; i < 10; i++)
            {
                var product = new Roofing
                {
                    ProductId = i,
                    Description = $"This is product #{i}",
                    DoNotUse = $"Product {i} property that shouldn't show up!"
                };

                products.Add(product);
            }

            var contract = new Contract
            {
                Products = products
            };

            var document = contract.ToMutableDocument($"contract::{contractId}");

            Database.Save(document);
        }

        public void Get_Clicked(object sender, EventArgs e)
        {
            var query = QueryBuilder.Select(SelectResult.Expression(Meta.ID), SelectResult.All())
                        .From(DataSource.Database(Database));

            var results = query?.Execute()?.AllResults();

            var contracts = results?.ToObjects<Contract>();

            // I use break points like this here, because I'm lame like that :)
            string test = "";
        }
    }

    public class Contract
    {
        public List<Roofing> Products { get; set; }
    }

    public abstract class Product
    {
        public int ProductId { get; set; }
    }

    public class Roofing : Product
    {
        public string Description { get; set; }

        [JsonIgnore]
        public string DoNotUse { get; set; }
    }
}
